(window.webpackJsonp=window.webpackJsonp||[]).push([[4],{yFgI:function(e,t,n){"use strict";n.r(t),n.d(t,"_frontmatter",(function(){return c})),n.d(t,"default",(function(){return l}));n("5hJT"),n("W1QL"),n("K/PF"),n("t91x"),n("75LO"),n("PJhk");var a=n("/FXl"),r=n("TjRS");n("aD51");function o(){return(o=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var a in n)Object.prototype.hasOwnProperty.call(n,a)&&(e[a]=n[a])}return e}).apply(this,arguments)}var c={};void 0!==c&&c&&c===Object(c)&&Object.isExtensible(c)&&!c.hasOwnProperty("__filemeta")&&Object.defineProperty(c,"__filemeta",{configurable:!0,value:{name:"_frontmatter",filename:"basic/dependecies_injection.mdx"}});var s={_frontmatter:c},i=r.a;function l(e){var t=e.components,n=function(e,t){if(null==e)return{};var n,a,r={},o=Object.keys(e);for(a=0;a<o.length;a++)n=o[a],t.indexOf(n)>=0||(r[n]=e[n]);return r}(e,["components"]);return Object(a.b)(i,o({},s,n,{components:t,mdxType:"MDXLayout"}),Object(a.b)("h1",{id:"dependencies-injection"},"Dependencies Injection"),Object(a.b)("p",null,"If you are familiar with ",Object(a.b)("a",o({parentName:"p"},{href:"https://angular.io"}),"Angular")," or ",Object(a.b)("a",o({parentName:"p"},{href:"https://nestjs.com/"}),"NestJS"),", you may already be familiar with ",Object(a.b)("strong",{parentName:"p"},"Dependencies Injection"),"."),Object(a.b)("h2",{id:"module"},"Module"),Object(a.b)("p",null,"In ayanami world, every ",Object(a.b)("strong",{parentName:"p"},"Module")," is ",Object(a.b)("strong",{parentName:"p"},"Injectable"),". So you can easily combine modules by ",Object(a.b)("strong",{parentName:"p"},"Inject")," one to the others."),Object(a.b)("pre",null,Object(a.b)("code",o({parentName:"pre"},{className:"language-ts"}),"@Module('A')\nclass ModuleA extends Ayanami<AState> {\n  defaultState = {}\n}\n\n@Module('B')\nclass ModuleB extends Ayanami<BState> {\n  defaultState = {}\n\n  constructor(private readonly moduleA: ModuleA) {\n    super()\n  }\n}\n")),Object(a.b)("h3",{id:"access-appstate-from-the-other-module"},"Access ",Object(a.b)("inlineCode",{parentName:"h3"},"AppState")," from the other ",Object(a.b)("strong",{parentName:"h3"},"Module")),Object(a.b)("p",null,"Unlike ",Object(a.b)("strong",{parentName:"p"},"Redux"),", Ayanami does not have ",Object(a.b)("strong",{parentName:"p"},"Global Store")," object to store the whole state in application.\nBut with ",Object(a.b)("strong",{parentName:"p"},"Dependencies Injection"),", we still can access state from the other parts in our application:"),Object(a.b)("pre",null,Object(a.b)("code",o({parentName:"pre"},{className:"language-ts"}),"@Module('A')\nclass ModuleA extends Ayanami<AState> {\n  defaultState = {}\n}\n\n@Module('B')\nclass ModuleB extends Ayanami<BState> {\n  defaultState = {}\n\n  constructor(private readonly moduleA: ModuleA) {\n    super()\n  }\n\n  @Effect()\n  addAndSync(payload$: Observable<number>) {\n    return payload$.pipe(\n      withLatestFrom(this.moduleA.state$),\n      map(([payload, stateA]) => {\n        ...\n      })\n    )\n  }\n}\n")),Object(a.b)("h3",{id:"trigger-actions-of-the-other-modules"},"Trigger actions of the other modules"),Object(a.b)("p",null,"Just be similar with ",Object(a.b)("a",o({parentName:"p"},{href:"./action.md#emit-actions-in-effect-using-actionscreator"}),"Emit actions in Effect using ActionsCreator"),", we can create ",Object(a.b)("inlineCode",{parentName:"p"},"Action")," using ",Object(a.b)("strong",{parentName:"p"},"ActionsCreator")," in the other ",Object(a.b)("inlineCode",{parentName:"p"},"Module class"),"."),Object(a.b)("pre",null,Object(a.b)("code",o({parentName:"pre"},{className:"language-ts"}),"@Module('A')\nclass ModuleA extends Ayanami<AState> {\n  defaultState = {}\n\n  @ImmerReducer()\n  set(state: Draft<AState>, payload: string) {\n    state.syncFromB = payload\n  }\n}\n\n@Module('B')\nclass ModuleB extends Ayanami<BState> {\n  defaultState = {}\n\n  constructor(private readonly moduleA: ModuleA) {\n    super()\n  }\n\n  @Effect()\n  addAndSync(payload$: Observable<number>) {\n    return payload$.pipe(\n      withLatestFrom(this.moduleA.state$),\n      map(([payload, stateA]) => {\n        return this.moduleA.getActions().set(`${stateA.syncFromB}${payload}`)\n      })\n    )\n  }\n}\n")),Object(a.b)("h2",{id:"service"},"Service"),Object(a.b)("p",null,"If you want create a pure ",Object(a.b)("em",{parentName:"p"},"Service")," which seperated from ",Object(a.b)("inlineCode",{parentName:"p"},"Module class"),", you can just decorate it by ",Object(a.b)("inlineCode",{parentName:"p"},"Injectable")," decorator from ayanami."),Object(a.b)("pre",null,Object(a.b)("code",o({parentName:"pre"},{className:"language-ts"}),"\n@Module('Simple')\nclass SimpleModule extends Ayanami<SimpleState> {\n  defaultState = {}\n\n  constructor(private readonly httpClient: HttpClient) {\n    super()\n  }\n\n  @Effect()\n  create(payload$: Observable<CreateEntityPayload>) {\n    return payload$.pipe(\n      withLatestFrom(this.state$),\n      exhaustMap(([payload, state]) => {\n        return this.httpClient.post(`/resources/${state.id}`, {\n          body: payload,\n        })\n      })\n    )\n  }\n}\n")),Object(a.b)("pre",null,Object(a.b)("code",o({parentName:"pre"},{className:"language-ts"}),"import { Injectable } from 'ayanami'\nimport { Observable } from 'rxjs'\n\n@Injectable()\nexport class HttpClient {\n  constructor(private readonly tracer: Tracer) {}\n\n  get () {}\n  post<T>(config: Config = {}): Observable<T> {\n    return this.send<T>({\n      ...config,\n      method: 'POST',\n    })\n  }\n  delete() {}\n  put() {}\n\n  private send<T>(config: Config): Observable<T> {\n    return this.tracer.send(config)\n  }\n}\n\n")),Object(a.b)("pre",null,Object(a.b)("code",o({parentName:"pre"},{className:"language-ts"}),"import { Injectable } from 'ayanami'\nimport { Observable } from 'rxjs'\n\nexport type TraceId = string & {\n  readonly traceIdTag: unique symbol\n}\n\n@Injectable()\nexport class Tracer {\n  send<T>(config: Config): Observable<T> {\n    const traceId = this.generateTraceId()\n    this.traceStart(traceId)\n    return new Observable<T>((observer) => {\n      const { config, abortController } = this.convertConfig(config, traceId)\n      fetch(config).then((res) => {\n        this.traceEnd(traceId, res)\n        return res.json()\n      }).then((data) => {\n        observer.next(data)\n        observer.complete()\n      }).catch((e) => {\n        observer.error(e)\n      })\n      return () => {\n        abortController.abort()\n      }\n    })\n  }\n\n  private convertConfig(config: Config, traceId: TraceId): { config: FetchInit, abortController: AbortController } {}\n\n  private traceStart(traceId: TraceId) {}\n\n  private traceEnd(traceId: TraceId, res: Response) {}\n\n  private generateTraceId(): TraceId {}\n}\n")))}l&&l===Object(l)&&Object.isExtensible(l)&&!l.hasOwnProperty("__filemeta")&&Object.defineProperty(l,"__filemeta",{configurable:!0,value:{name:"MDXContent",filename:"basic/dependecies_injection.mdx"}}),l.isMDXComponent=!0}}]);
//# sourceMappingURL=component---basic-dependecies-injection-mdx-11d72f4de422c0f8049f.js.map